config/routes.rb
Rails.application.routes.draw do
  resources :operational_systems
  resources :tools
  resources :projects
  resources :languages
  
  get "/users/login" => "login#index"
  post "/users/login" => "login#create"
  get "/users/logout" => "login#logout"
  resources :users

  root :to => "login#index"

	get 'auth/:provider/callback', to: 'omni_auth_login#create'
  get 'auth/failure', to: redirect('/')
  get 'signout', to: 'omni_auth_login#destroy'


end

app/models/tool.rb
class Tool < ActiveRecord::Base
	has_many :projects
end

app/controllers/tools_controller.rb
class ToolsController < ApplicationController
  before_action :set_tool, only: [:show, :edit, :update, :destroy]

  # GET /tools
  def index
    @tools = Tool.all
  end

  # GET /tools/1
  def show
  end

  # GET /tools/new
  def new
    @tool = Tool.new
  end

  # GET /tools/1/edit
  def edit
  end

  # POST /tools
  def create
    @tool = Tool.new(tool_params)

    if @tool.save
      redirect_to @tool, notice: 'Tool was successfully created.'
    else
      render :new
    end
  end

  # PATCH/PUT /tools/1
  def update
    if @tool.update(tool_params)
      redirect_to @tool, notice: 'Tool was successfully updated.'
    else
      render :edit
    end
  end

  # DELETE /tools/1
  def destroy
    @tool.destroy
    redirect_to tools_url, notice: 'Tool was successfully destroyed.'
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_tool
      @tool = Tool.find(params[:id])
    end

    # Only allow a trusted parameter "white list" through.
    def tool_params
      params.require(:tool).permit(:name)
    end
end

app/helpers/tools_helper.rb
module ToolsHelper
end

app/views/tools/_form.html.erb
<%= form_for(@tool) do |f| %>
  <% if @tool.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@tool.errors.count, "error") %> prohibited this tool from being saved:</h2>

      <ul>
      <% @tool.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/tools/edit.html.erb
<h1>Editing Tool</h1>

<%= render 'form' %>

<%= link_to 'Show', @tool %> |
<%= link_to 'Back', tools_path %>

app/views/tools/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Tools</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @tools.each do |tool| %>
      <tr>
        <td><%= tool.name %></td>
        <td><%= link_to 'Show', tool %></td>
        <td><%= link_to 'Edit', edit_tool_path(tool) %></td>
        <td><%= link_to 'Destroy', tool, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Tool', new_tool_path %>

app/views/tools/new.html.erb
<h1>New Tool</h1>

<%= render 'form' %>

<%= link_to 'Back', tools_path %>

app/views/tools/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @tool.name %>
</p>

<%= link_to 'Edit', edit_tool_path(@tool) %> |
<%= link_to 'Back', tools_path %>